searchNodes=[{"doc":"","ref":"Delta.html","title":"Delta","type":"module"},{"doc":"Compacts Delta to satisfy compactness requirement. Examples iex&gt; delta = [ Op . insert ( &quot;Hel&quot; ) , Op . insert ( &quot;lo&quot; ) , Op . insert ( &quot;World&quot; , %{ &quot;bold&quot; =&gt; true } ) ] iex&gt; Delta . compact ( delta ) [ %{ &quot;insert&quot; =&gt; &quot;Hello&quot; } , %{ &quot;insert&quot; =&gt; &quot;World&quot; , &quot;attributes&quot; =&gt; %{ &quot;bold&quot; =&gt; true } } ]","ref":"Delta.html#compact/1","title":"Delta.compact/1","type":"function"},{"doc":"Returns a new Delta that is equivalent to applying the operations of one Delta, followed by another Delta Examples iex&gt; a = [ Op . insert ( &quot;abc&quot; ) ] iex&gt; b = [ Op . retain ( 1 ) , Op . delete ( 1 ) ] iex&gt; Delta . compose ( a , b ) [ %{ &quot;insert&quot; =&gt; &quot;ac&quot; } ]","ref":"Delta.html#compose/2","title":"Delta.compose/2","type":"function"},{"doc":"Returns a new Delta that is equivalent to applying Deltas one by one Examples iex&gt; a = [ Op . insert ( &quot;ac&quot; ) ] iex&gt; b = [ Op . retain ( 1 ) , Op . insert ( &quot;b&quot; ) ] iex&gt; c = [ Op . delete ( 1 ) ] iex&gt; Delta . compose_all ( [ a , b , c ] ) [ %{ &quot;insert&quot; =&gt; &quot;bc&quot; } ]","ref":"Delta.html#compose_all/1","title":"Delta.compose_all/1","type":"function"},{"doc":"Concatenates two Deltas. Examples iex&gt; a = [ Op . insert ( &quot;Hel&quot; ) ] iex&gt; b = [ Op . insert ( &quot;lo&quot; ) ] iex&gt; Delta . concat ( a , b ) [ %{ &quot;insert&quot; =&gt; &quot;Hello&quot; } ]","ref":"Delta.html#concat/2","title":"Delta.concat/2","type":"function"},{"doc":"","ref":"Delta.html#get_handler!/1","title":"Delta.get_handler!/1","type":"function"},{"doc":"Returns an inverted delta that has the opposite effect of against a base document delta. That is base |&gt; Delta.compose(change) |&gt; Delta.compose(inverted) == base. Examples iex&gt; base = [ Op . insert ( &quot;Hello \\n World&quot; ) ] iex&gt; change = [ ...&gt; Op . retain ( 6 , %{ &quot;bold&quot; =&gt; true } ) , ...&gt; Op . delete ( 5 ) , ...&gt; Op . insert ( &quot;!&quot; ) , ...&gt; ] iex&gt; inverted = Delta . invert ( change , base ) [ %{ &quot;retain&quot; =&gt; 6 , &quot;attributes&quot; =&gt; %{ &quot;bold&quot; =&gt; nil } } , %{ &quot;insert&quot; =&gt; &quot;World&quot; } , %{ &quot;delete&quot; =&gt; 1 } , ] iex&gt; base |&gt; Delta . compose ( change ) |&gt; Delta . compose ( inverted ) == base true","ref":"Delta.html#invert/2","title":"Delta.invert/2","type":"function"},{"doc":"Pushes an operation to a reversed Delta honouring semantics. Note: that reversed delta does not represent a reversed text, but rather a list of operations that was naively reversed during programmatic manipulations. This function is normally only used by other functions which reverse the list back in the end. Examples iex&gt; delta = [ Op . insert ( &quot;World&quot; , %{ &quot;italic&quot; =&gt; true } ) , Op . insert ( &quot;Hello&quot; , %{ &quot;bold&quot; =&gt; true } ) ] iex&gt; op = Op . insert ( &quot;!&quot; ) iex&gt; Delta . push ( delta , op ) [ %{ &quot;insert&quot; =&gt; &quot;!&quot; } , %{ &quot;insert&quot; =&gt; &quot;World&quot; , &quot;attributes&quot; =&gt; %{ &quot;italic&quot; =&gt; true } } , %{ &quot;insert&quot; =&gt; &quot;Hello&quot; , &quot;attributes&quot; =&gt; %{ &quot;bold&quot; =&gt; true } } ] iex&gt; delta = [ Op . insert ( &quot;World&quot; ) , Op . insert ( &quot;Hello&quot; , %{ &quot;bold&quot; =&gt; true } ) ] iex&gt; op = Op . insert ( &quot;!&quot; ) iex&gt; Delta . push ( delta , op ) [ %{ &quot;insert&quot; =&gt; &quot;World!&quot; } , %{ &quot;insert&quot; =&gt; &quot;Hello&quot; , &quot;attributes&quot; =&gt; %{ &quot;bold&quot; =&gt; true } } ]","ref":"Delta.html#push/2","title":"Delta.push/2","type":"function"},{"doc":"Returns the size of delta. Examples iex&gt; delta = [ Op . insert ( &quot;abc&quot; ) , Op . retain ( 2 ) , Op . delete ( 1 ) ] iex&gt; Delta . size ( delta ) 6","ref":"Delta.html#size/1","title":"Delta.size/1","type":"function"},{"doc":"Attempts to take len characters starting from index . Note: note that due to the way it's implemented this operation can potentially raise if the resulting text isn't a valid UTF-8 encoded string Examples iex&gt; delta = [ Op . insert ( &quot;Hello World&quot; ) ] iex&gt; Delta . slice ( delta , 6 , 3 ) [ %{ &quot;insert&quot; =&gt; &quot;Wor&quot; } ] iex&gt; delta = [ Op . insert ( &quot;01🙋45&quot; ) ] iex&gt; Delta . slice ( delta , 1 , 2 ) ** (RuntimeError) Encoding failed in take_partial {&quot;1🙋45&quot;, %{&quot;insert&quot; =&gt; &quot;1🙋45&quot;}, 2, {:incomplete, &quot;1&quot;, &lt;&lt;216, 61&gt;&gt;}, {:error, &quot;&quot;, &lt;&lt;222, 75, 0, 52, 0, 53&gt;&gt;}}","ref":"Delta.html#slice/3","title":"Delta.slice/3","type":"function"},{"doc":"Takes len or fewer characters from index position. Variable len allows to not cut things like emojis in half. Examples iex&gt; delta = [ Op . insert ( &quot;Hello World&quot; ) ] iex&gt; Delta . slice_max ( delta , 6 , 3 ) [ %{ &quot;insert&quot; =&gt; &quot;Wor&quot; } ] iex&gt; delta = [ Op . insert ( &quot;01🙋45&quot; ) ] iex&gt; Delta . slice_max ( delta , 1 , 2 ) [ %{ &quot;insert&quot; =&gt; &quot;1&quot; } ]","ref":"Delta.html#slice_max/3","title":"Delta.slice_max/3","type":"function"},{"doc":"Splits delta at the given index. Options :align - when true , allow moving index left if we're likely to split a grapheme otherwise. Examples iex&gt; delta = [ Op . insert ( &quot;Hello World&quot; ) ] iex&gt; Delta . split ( delta , 5 ) { [ %{ &quot;insert&quot; =&gt; &quot;Hello&quot; } ] , [ %{ &quot;insert&quot; =&gt; &quot; World&quot; } ] } iex&gt; delta = [ Op . insert ( &quot;01🙋45&quot; ) ] iex&gt; Delta . split ( delta , 3 , align : true ) { [ %{ &quot;insert&quot; =&gt; &quot;01&quot; } ] , [ %{ &quot;insert&quot; =&gt; &quot;🙋45&quot; } ] }","ref":"Delta.html#split/3","title":"Delta.split/3","type":"function"},{"doc":"Transforms given delta against another's operations. This accepts an optional priority argument (default: false), used to break ties. If true, the first delta takes priority over other, that is, its actions are considered to happen &quot;first.&quot; Examples iex&gt; a = [ Op . insert ( &quot;a&quot; ) ] iex&gt; b = [ Op . insert ( &quot;b&quot; ) , Op . retain ( 5 ) , Op . insert ( &quot;c&quot; ) ] iex&gt; Delta . transform ( a , b , true ) [ %{ &quot;retain&quot; =&gt; 1 } , %{ &quot;insert&quot; =&gt; &quot;b&quot; } , %{ &quot;retain&quot; =&gt; 5 } , %{ &quot;insert&quot; =&gt; &quot;c&quot; } , ] iex&gt; Delta . transform ( a , b ) [ %{ &quot;insert&quot; =&gt; &quot;b&quot; } , %{ &quot;retain&quot; =&gt; 6 } , %{ &quot;insert&quot; =&gt; &quot;c&quot; } , ]","ref":"Delta.html#transform/3","title":"Delta.transform/3","type":"function"},{"doc":"","ref":"Delta.html#t:t/0","title":"Delta.t/0","type":"type"},{"doc":"","ref":"Delta.Attr.html","title":"Delta.Attr","type":"module"},{"doc":"","ref":"Delta.Attr.html#compose/3","title":"Delta.Attr.compose/3","type":"function"},{"doc":"","ref":"Delta.Attr.html#invert/2","title":"Delta.Attr.invert/2","type":"function"},{"doc":"","ref":"Delta.Attr.html#transform/3","title":"Delta.Attr.transform/3","type":"function"},{"doc":"A module implementing EmbedHandler behaviour is required to make compose , transform and invert operations possible for custom embeds. Suppose we want to have a custom image embed handler, that will always prefer image urls that start with https:// defmodule ImageEmbed do @behaviour Delta.EmbedHandler @impl Delta.EmbedHandler def name , do : &quot;image&quot; @impl Delta.EmbedHandler def compose ( url1 , url2 , _keep_nil? ) do choose_https ( url1 , url2 ) end @impl Delta.EmbedHandler def transform ( url1 , url2 , _priority? \\ false ) do choose_https ( url1 , url2 ) end @impl Delta.EmbedHandler def invert ( change , base ) do choose_https ( change , base ) end defp choose_https ( url1 , url2 ) do case { url1 , url2 } do { &quot;https&quot; &lt;&gt; _ , _ } -&gt; url1 { _ , &quot;https&quot; &lt;&gt; _ } -&gt; url2 { _ , _ } -&gt; url1 end end end Now we just need to add our module to config: config :delta , custom_embeds : [ ImageEmbed ] Examples iex&gt; base = Op . insert ( %{ &quot;image&quot; =&gt; &quot;update me&quot; } ) iex&gt; a = Op . retain ( %{ &quot;image&quot; =&gt; &quot;http://quilljs.com/assets/images/icon.png&quot; } ) iex&gt; b = Op . retain ( %{ &quot;image&quot; =&gt; &quot;https://quilljs.com/assets/images/icon.png&quot; } ) iex&gt; Delta . transform ( [ base , a ] , [ base , b ] ) [ %{ &quot;insert&quot; =&gt; %{ &quot;image&quot; =&gt; &quot;update me&quot; } } , %{ &quot;retain&quot; =&gt; 1 } , %{ &quot;retain&quot; =&gt; %{ &quot;image&quot; =&gt; &quot;https://quilljs.com/assets/images/icon.png&quot; } } ]","ref":"Delta.EmbedHandler.html","title":"Delta.EmbedHandler","type":"behaviour"},{"doc":"","ref":"Delta.EmbedHandler.html#c:compose/3","title":"Delta.EmbedHandler.compose/3","type":"callback"},{"doc":"","ref":"Delta.EmbedHandler.html#c:invert/2","title":"Delta.EmbedHandler.invert/2","type":"callback"},{"doc":"","ref":"Delta.EmbedHandler.html#c:name/0","title":"Delta.EmbedHandler.name/0","type":"callback"},{"doc":"","ref":"Delta.EmbedHandler.html#c:transform/3","title":"Delta.EmbedHandler.transform/3","type":"callback"},{"doc":"","ref":"Delta.EmbedHandler.html#t:embed/0","title":"Delta.EmbedHandler.embed/0","type":"type"},{"doc":"","ref":"Delta.EmbedHandler.html#t:t/0","title":"Delta.EmbedHandler.t/0","type":"type"},{"doc":"","ref":"Delta.Op.html","title":"Delta.Op","type":"module"},{"doc":"","ref":"Delta.Op.html#compose/2","title":"Delta.Op.compose/2","type":"function"},{"doc":"A shorthand for new(&quot;delete&quot;, value, attributes) . See new/3 . Examples iex&gt; Op . delete ( 1 , %{ &quot;bold&quot; =&gt; true } ) %{ &quot;delete&quot; =&gt; 1 , &quot;attributes&quot; =&gt; %{ &quot;bold&quot; =&gt; true } }","ref":"Delta.Op.html#delete/2","title":"Delta.Op.delete/2","type":"function"},{"doc":"A shorthand for type?(op, &quot;delete&quot;, type) . See type?/3 . Examples iex&gt; Op . delete ( 1 ) |&gt; Op . delete? ( ) true","ref":"Delta.Op.html#delete?/2","title":"Delta.Op.delete?/2","type":"function"},{"doc":"Gets two embeds' data. An embed is always a one-key map Examples iex&gt; Op . get_embed_data! ( ...&gt; %{ &quot;image&quot; =&gt; &quot;https://quilljs.com/assets/images/icon.png&quot; } , ...&gt; %{ &quot;image&quot; =&gt; &quot;https://quilljs.com/assets/images/icon2.png&quot; } ...&gt; ) { &quot;image&quot; , &quot;https://quilljs.com/assets/images/icon.png&quot; , &quot;https://quilljs.com/assets/images/icon2.png&quot; }","ref":"Delta.Op.html#get_embed_data!/2","title":"Delta.Op.get_embed_data!/2","type":"function"},{"doc":"Returns true if operation has attributes Examples iex&gt; Op . has_attributes? ( %{ &quot;insert&quot; =&gt; &quot;Hello&quot; , &quot;attributes&quot; =&gt; %{ &quot;bool&quot; =&gt; true } } ) true iex&gt; Op . has_attributes? ( %{ &quot;insert&quot; =&gt; &quot;Hello&quot; } ) false","ref":"Delta.Op.html#has_attributes?/1","title":"Delta.Op.has_attributes?/1","type":"function"},{"doc":"A shorthand for new(&quot;insert&quot;, value, attributes) . See new/3 . Examples iex&gt; Op . insert ( &quot;Hello&quot; , %{ &quot;bold&quot; =&gt; true } ) %{ &quot;insert&quot; =&gt; &quot;Hello&quot; , &quot;attributes&quot; =&gt; %{ &quot;bold&quot; =&gt; true } }","ref":"Delta.Op.html#insert/2","title":"Delta.Op.insert/2","type":"function"},{"doc":"A shorthand for type?(op, &quot;insert&quot;, type) . See type?/3 . Examples iex&gt; Op . insert ( &quot;Hello&quot; ) |&gt; Op . insert? ( ) true","ref":"Delta.Op.html#insert?/2","title":"Delta.Op.insert?/2","type":"function"},{"doc":"Create a new operation. Note that operations are maps, and not structs. Examples iex&gt; Op . new ( &quot;insert&quot; , &quot;Hello&quot; , %{ &quot;bold&quot; =&gt; true } ) %{ &quot;insert&quot; =&gt; &quot;Hello&quot; , &quot;attributes&quot; =&gt; %{ &quot;bold&quot; =&gt; true } }","ref":"Delta.Op.html#new/3","title":"Delta.Op.new/3","type":"function"},{"doc":"A shorthand for new(&quot;retain&quot;, value, attributes) . See new/3 . Examples iex&gt; Op . retain ( 1 , %{ &quot;bold&quot; =&gt; true } ) %{ &quot;retain&quot; =&gt; 1 , &quot;attributes&quot; =&gt; %{ &quot;bold&quot; =&gt; true } }","ref":"Delta.Op.html#retain/2","title":"Delta.Op.retain/2","type":"function"},{"doc":"A shorthand for type?(op, &quot;insert&quot;, type) . See type?/3 . Examples iex&gt; Op . retain ( 1 ) |&gt; Op . retain? ( ) true","ref":"Delta.Op.html#retain?/2","title":"Delta.Op.retain?/2","type":"function"},{"doc":"Returns operation size. Examples iex&gt; Op . insert ( &quot;Hello&quot; ) |&gt; Op . size ( ) 5 iex&gt; Op . retain ( 3 ) |&gt; Op . size ( ) 3","ref":"Delta.Op.html#size/1","title":"Delta.Op.size/1","type":"function"},{"doc":"Takes length characters from an operation and returns it together with the remaining part in a tuple. Options :align - when true , allow moving index left if we're likely to split a grapheme otherwise. Examples iex&gt; Op . insert ( &quot;Hello&quot; ) |&gt; Op . take ( 3 ) { %{ &quot;insert&quot; =&gt; &quot;Hel&quot; } , %{ &quot;insert&quot; =&gt; &quot;lo&quot; } } iex&gt; assert_raise RuntimeError , fn -&gt; Op . insert ( &quot;🏴󠁧󠁢󠁳󠁣󠁴󠁿&quot; ) |&gt; Op . take ( 1 ) end iex&gt; Op . insert ( &quot;🏴󠁧󠁢󠁳󠁣󠁴󠁿&quot; ) |&gt; Op . take ( 1 , align : true ) { %{ &quot;insert&quot; =&gt; &quot;&quot; } , %{ &quot;insert&quot; =&gt; &quot;🏴󠁧󠁢󠁳󠁣󠁴󠁿&quot; } }","ref":"Delta.Op.html#take/3","title":"Delta.Op.take/3","type":"function"},{"doc":"Returns text size. Examples iex&gt; Op . text_size ( &quot;Hello&quot; ) 5 iex&gt; Op . text_size ( &quot;🏴󠁧󠁢󠁳󠁣󠁴󠁿&quot; ) 14","ref":"Delta.Op.html#text_size/1","title":"Delta.Op.text_size/1","type":"function"},{"doc":"","ref":"Delta.Op.html#transform/3","title":"Delta.Op.transform/3","type":"function"},{"doc":"","ref":"Delta.Op.html#transform/4","title":"Delta.Op.transform/4","type":"function"},{"doc":"Returns true if operation is of type type . Optionally check against more specific value_type . Examples iex&gt; Op . insert ( &quot;Hello&quot; ) |&gt; Op . type? ( &quot;insert&quot; ) true iex&gt; Op . insert ( &quot;Hello&quot; ) |&gt; Op . type? ( &quot;insert&quot; , :string ) true iex&gt; Op . insert ( &quot;Hello&quot; ) |&gt; Op . type? ( &quot;insert&quot; , :number ) false iex&gt; Op . retain ( 1 ) |&gt; Op . type? ( &quot;retain&quot; , :number ) true","ref":"Delta.Op.html#type?/3","title":"Delta.Op.type?/3","type":"function"},{"doc":"Stand-in type while attributes is keyed with String.t() instead of Atom.t()","ref":"Delta.Op.html#t:attributes/0","title":"Delta.Op.attributes/0","type":"type"},{"doc":"Stand-in type while operators are keyed with String.t() instead of Atom.t() %{delete: pos_integer()}","ref":"Delta.Op.html#t:delete_op/0","title":"Delta.Op.delete_op/0","type":"type"},{"doc":"Stand-in type while operators are keyed with String.t() instead of Atom.t() %{insert: String.t() | EmbedHandler.embed(), ...}","ref":"Delta.Op.html#t:insert_op/0","title":"Delta.Op.insert_op/0","type":"type"},{"doc":"Stand-in type while operators are keyed with String.t() instead of Atom.t()","ref":"Delta.Op.html#t:operation/0","title":"Delta.Op.operation/0","type":"type"},{"doc":"Stand-in type while operators are keyed with String.t() instead of Atom.t() %{retain: pos_integer() | EmbedHandler.embed()}","ref":"Delta.Op.html#t:retain_op/0","title":"Delta.Op.retain_op/0","type":"type"},{"doc":"","ref":"Delta.Op.html#t:t/0","title":"Delta.Op.t/0","type":"type"},{"doc":"[ Simple yet expressive format to describe documents' contents and changes 🗃 Deltas are a simple, yet expressive format that can be used to describe contents and changes. The format is a strict subset of JSON, is human readable, and easily parsible by machines. Deltas can describe any rich-text document, includes all text and formatting information, without the ambiguity and complexity of HTML. The Delta format is suitable for Operational Transform and can be used in real-time, collaborative document editors (e.g. Slab, Google Docs). A walkthough of the motivation and design thinking behind Deltas are on Designing the Delta Format . See the Documentation .","ref":"readme.html","title":"Delta","type":"extras"},{"doc":"Add delta to your project dependencies in mix.exs : def deps do [ { :delta , &quot;~&gt; 0.3.0&quot; } ] end","ref":"readme.html#installation","title":"Delta - Installation","type":"extras"},{"doc":"A Delta is made up of a list of operations, which describe changes to a document. These can be insert , delete or retain . These operations do not take an index, but instead describe the change at the current index. Retains are used to &quot;keep&quot; parts of the document. Quick Example alias Delta.Op # Document with text &quot;Gandalf the Grey&quot;, with &quot;Gandalf&quot; bolded # and &quot;Grey&quot; in grey delta = [ Op . insert ( &quot;Gandalf&quot; , %{ &quot;bold&quot; =&gt; true } ) , Op . insert ( &quot; the &quot; ) , Op . insert ( &quot;Grey&quot; , %{ &quot;color&quot; =&gt; &quot;#ccc&quot; } ) , ] # Define change intended to be applied to above: # Keep the first 12 characters, delete the next 4, # and insert a white &quot;White&quot; death = [ Op . retain ( 12 ) , Op . delete ( 4 ) , Op . insert ( &quot;White&quot; , %{ &quot;color&quot; =&gt; &quot;#fff&quot; } ) , ] # Applying the change: Delta . compose ( delta , death ) # =&gt; [ # %{&quot;insert&quot; =&gt; &quot;Gandalf&quot;, &quot;attributes&quot; =&gt; %{&quot;bold&quot; =&gt; true}}, # %{&quot;insert&quot; =&gt; &quot; the &quot;}, # %{&quot;insert&quot; =&gt; &quot;White&quot;, &quot;attributes&quot; =&gt; %{&quot;color&quot; =&gt; &quot;#fff&quot;}}, # ]","ref":"readme.html#usage","title":"Delta - Usage","type":"extras"},{"doc":"Insert Insert operations have an insert key defined. A String value represents inserting text. Any other type represents inserting an embed (however only one level of object comparison will be performed for equality). In both cases of text and embeds, an optional attributes key can be defined with a map to describe additonal formatting information. Formats can be changed by the retain operation. # Insert a text Op . insert ( &quot;Some Text&quot; ) # Insert a bolded text Op . insert ( &quot;Bolded Text&quot; , %{ &quot;bold&quot; =&gt; true } ) # Insert a link Op . insert ( &quot;Google&quot; , %{ &quot;link&quot; =&gt; &quot;https://google.com&quot; } ) # Insert an embed Op . insert ( %{ &quot;image&quot; =&gt; &quot;https://app.com/logo.png&quot; } , %{ &quot;alt&quot; =&gt; &quot;App Logo&quot; } ) # Insert another embed Op . insert ( %{ &quot;video&quot; =&gt; &quot;https://www.youtube.com/watch?v=dQw4w9WgXcQ&quot; } , %{ &quot;width&quot; =&gt; 420 , &quot;height&quot; =&gt; 315 } ) Delete Delete operations have a positive integer delete key defined representing the number of characters to delete. All embeds have a length of 1. # Delete the next 10 characters Op . delete ( 10 ) Retain Retain operations have a positive integer retain key defined representing the number of characters to keep (other libraries might use the name keep or skip). An optional attributes key can be defined with a map to describe formatting changes to the character range. A value of nil in the attributes map represents removal of that key. Note: It is not necessary to retain the last characters of a document as this is implied. # Keep the next 5 characters Op . retain ( 5 ) # Keep and bold the next 5 characters Op . retain ( 5 , %{ &quot;bold&quot; =&gt; true } ) # Keep and unbold the next 5 characters Op . retain ( 5 , %{ &quot;bold&quot; =&gt; nil } )","ref":"readme.html#operations","title":"Delta - Operations","type":"extras"},{"doc":"Operational Transform (OT) is a technology for building collabortive experiences, and is especially useful in application sharing and building real-time document editors that support multi-user collaboration (e.g. Google Docs, Slab). Delta supports OT out of the box and can be very useful in employing Operational Transform techniques in Elixir. It supports the following properties: Compose Returns a new Delta that is equivalent to applying the operations of one Delta, followed by another Delta: a = [ Op . insert ( &quot;abc&quot; ) ] b = [ Op . retain ( 1 ) , Op . delete ( 1 ) ] Delta . compose ( a , b ) # =&gt; [%{&quot;insert&quot; =&gt; &quot;ac&quot;}] Transform Transforms given delta against another's operations. This accepts an optional priority argument (default: false ), used to break ties. If true , the first delta takes priority over other, that is, its actions are considered to happen &quot;first.&quot; a = [ Op . insert ( &quot;a&quot; ) ] b = [ Op . insert ( &quot;b&quot; ) , Op . retain ( 5 ) , Op . insert ( &quot;c&quot; ) ] Delta . transform ( a , b , true ) # =&gt; [ # %{&quot;retain&quot; =&gt; 1}, # %{&quot;insert&quot; =&gt; &quot;b&quot;}, # %{&quot;retain&quot; =&gt; 5}, # %{&quot;insert&quot; =&gt; &quot;c&quot;}, # ] Delta . transform ( a , b ) # =&gt; [ # %{&quot;insert&quot; =&gt; &quot;b&quot;}, # %{&quot;retain&quot; =&gt; 6}, # %{&quot;insert&quot; =&gt; &quot;c&quot;}, # ] Note that even though delete operations support attributes, it is only safe to use transform with deletes that don't have them. Invert Returns an inverted delta that has the opposite effect of against a base document delta. That is base |&gt; Delta.compose(change) |&gt; Delta.compose(inverted) == base . base = [ Op . insert ( &quot;Hello \\n World&quot; ) ] change = [ Op . retain ( 6 , %{ &quot;bold&quot; =&gt; true } ) , Op . delete ( 5 ) , Op . insert ( &quot;!&quot; ) , ] inverted = Delta . invert ( change , base ) # =&gt; [ # %{&quot;retain&quot; =&gt; 6, &quot;attributes&quot; =&gt; %{&quot;bold&quot; =&gt; nil}}, # %{&quot;insert&quot; =&gt; &quot;World&quot;}, # %{&quot;delete&quot; =&gt; 1}, # ] base |&gt; Delta . compose ( change ) |&gt; Delta . compose ( inverted ) == base # =&gt; true","ref":"readme.html#operational-transform","title":"Delta - Operational Transform","type":"extras"},{"doc":"Fork , Enhance, Send PR Lock issues with any bugs or feature requests Implement something from Roadmap Spread the word :heart:","ref":"readme.html#contributing","title":"Delta - Contributing","type":"extras"}]